
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>互联网应用的缓存实践分享 / iVAN</title>

    <meta name="description" content="互联网应用的缓存实践分享 简介 在当今互联网应用中,缓存作为一把尖刀利器对应用的性能起着举足轻重的作用.缓存的使用可以说无处不在,从应用请求的访问路径来看,用户user -&gt; 浏览器缓存 -&gt; 反向代理缓存-&gt; WEB服务器缓存 -&gt; 应用程序缓存 -&gt; 数据库缓存等,几乎每条链路都充斥着缓存的使用,当然交换机,网络适配器,硬盘上也有Cache 但这不是我们要讨论的范围.今天我们讨论的&quot;缓存&quot;,自然就是&quot;用空间换时间&quot;的算法.缓存就是把一些数据暂时存放 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">互联网应用的缓存实践分享</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>简介<br />
在当今互联网应用中，<a href="http://www.roncoo.com/course/view/af7d501667fe4a19a60e9467e6d2b3d9" rel="external nofollow noreferrer">缓存</a>作为一把尖刀利器对应用的性能起着举足轻重的作用。缓存的使用可以说无处不在，从应用请求的访问路径来看，用户user -&gt; 浏览器缓存 -&gt; 反向代理缓存-&gt; WEB服务器缓存 -&gt; 应用程序缓存 -&gt; <a href="http://www.roncoo.com/course/view/658088f6e77541f5835b61800314083e" rel="external nofollow noreferrer">数据库</a>缓存等，几乎每条链路都充斥着缓存的使用，当然交换机，网络适配器，硬盘上也有Cache 但这不是我们要讨论的范围。今天我们讨论的“缓存”，自然就是“用空间换时间”的算法。缓存就是把一些数据暂时存放于某些地方，可能是内存，也有可能硬盘。总之，目的就是为了避免某些耗时的操作。我们常见的耗时的操作，比如数据库的查询、一些数据的计算结果，或者是为了减轻服务器的压力。其实减轻压力也是因查询或计算，虽然短耗时，但操作很频繁，累加起来也很长，造成严重排队等情况，服务器抗不住。<br /><a href="http://static.roncoo.com/images/E42BcsddM4xJzXDpG7ndtMM6kfsBhSjb.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLnJvbmNvby5jb20vaW1hZ2VzL0U0MkJjc2RkTTR4SnpYRHBHN25kdE1NNmtmc0JoU2piLmpwZw==.jpg"></a></p>
<p>缓存介质<br />
虽然从硬件介质上来看，无非就是内存和硬盘两种，但从技术上，可以分成内存、硬盘文件、数据库。</p>
<p>内存 将缓存存储于内存中是最快的选择，无需额外的I/O开销，但是内存的缺点是没有持久化落地物理磁盘，一旦应用异常break down而重新启动，数据很难或者无法复原。</p>
<p>硬盘 一般来说，很多<a href="http://www.roncoo.com/course/view/af7d501667fe4a19a60e9467e6d2b3d9" rel="external nofollow noreferrer">缓存框架</a>会结合使用内存和硬盘，在内存分配空间满了或是在异常的情况下，可以被动或主动的将内存空间数据持久化到硬盘中，达到释放空间或备份数据的目的。</p>
<p>数据库 前面有提到，增加缓存的策略的目的之一就是为了减少数据库的I/O压力。这里所指的数据库只是简单的key-value存储结构的特殊NOSQL数据库（如BerkeleyDB和Redis），响应速度和吞吐量都远远高于我们常用的关系型数据库等。</p>
<p>缓存命中率<br />
缓存命中率通常指的是缓存查询命中总数与缓存查询总数的比率，应用缓存命中率越高越好，这是衡量缓存使用是否良好的重要指标。</p>
<p>缓存回收策略<br />
缓存的回收策略在分布式缓存中类型主要有如下几种<br />
1. 基于时间<br />
TTL:存活期，一条缓存自创建时间起多久后失效<br />
TTI:空闲期，一条缓存自最后读取或更新起多久后失效</p>
<ol>
<li>基于空间<br />
通常指的是设置存储空间大小，比如TAIR申请时空间大小，超过这个阈值后，会按照一定的策略算法移除数据。</li>
<li>基于容量<br />
通常指的是设置缓存条目数量大小，超过这个阈值后，会按照一定的策略算法移除数据。</li>
</ol>
<p>缓存系统的整体回收首先根据时间进行移除过期数据，如果超过空间或者容量设置的阈值，会根据相应的算法移除数据,移除数据的算法主要有LRU、FIFO、LFU，最常用的算法是LRU，分布式缓存memcached、redis以及tair都支持该算法，本地缓存guava cache、ehcache也同样支持LRU算法。</p>
<p>数据淘汰算法简要介绍：</p>
<p>FIFO(first in first out)<br />
先进先出策略，最先进入缓存的数据在缓存空间不够的情况下（超出最大元素限制）会被优先被清除掉，以腾出新的空间接受新的数据。策略算法主要比较缓存元素的创建时间。在数据实效性要求场景下可选择该类策略，优先保障最新数据可用。</p>
<p>LFU(less frequently used)<br />
最少使用策略，无论是否过期，根据元素的被使用次数判断，清除使用次数较少的元素释放空间。策略算法主要比较元素的hitCount（命中次数）。在保证高频数据有效性场景下，可选择这类策略。</p>
<p>LRU(least recently used)<br />
最近最少使用策略，无论是否过期，根据元素最后一次被使用的时间戳，清除最远使用时间戳的元素释放空间。策略算法主要比较元素最近一次被get使用时间。在热点数据场景下较适用，优先保证热点数据的有效性。</p>
<p>缓存使用场景与分类<br />
使用缓存的目的提高系统的整体性能，缓存的工作机制是先从缓存中读取数据，如果没有，则再从慢速设备上读取实际数据并同步到缓存。那些经常查询的数据、频繁访问的数据、热点数据、IO瓶颈数据、计算昂贵的数据、符合五分钟法则和局部性原理的数据都可以进行缓存。</p>
<p>在互联网应用中常见的缓存的场景主要：</p>
<p>数据库缓存： 随着业务量的上升，数据库存储的数据量越来越大，并发请求逐渐增大，随之而来的问题就是数据库系统的负载升高，响应延迟下降，严重的时候，甚至有可能因此而导致服务中断，这时启用缓存利器可以提高系统性能。<br />
临时数据存储： 应用程序需要维护大量临时数据，例如计数器、分布式锁、用户session等，将临时数据存储在分布式缓存中，可以降低内存管理的开销，改进应用程序工作负载。<br />
在互联网应用中，从应用与缓存耦合度角度缓存主要分为本地缓存、分布式缓存两大类。</p>
<p>本地缓存：指的是在应用中的缓存组件，其最大的优点是应用和cache是在同一个进程内部，请求缓存非常快速，没有过多的网络开销等，在单应用不需要集群支持或者集群情况下各节点无需互相通知的场景下使用本地缓存较合适；同时，它的缺点也是应为缓存跟应用程序耦合，多个应用程序无法直接的共享缓存，各应用或集群的各节点都需要维护自己的单独缓存，对内存是一种浪费。</p>
<p>Guava Cache、Ehcache、MapDB都可以实现JAVA堆内存本地缓存，谈堆内存其实JAVA还支持堆外内存，Ehcache 3.x、MapDB 3.x也同样支持堆外内存，堆外内存意味着把内存对象分配在Java虚拟机的堆以外的内存，这些内存直接受操作系统管理（而不是虚拟机），Netty就是使用堆外内存来管理内存，建议慎用堆外内存，使用不当容易导致OOM，关于堆外内存与堆内存接下来不做重点介绍。</p>
<p>分布式缓存：指的是与应用分离的缓存组件或服务，其最大的优点是自身就是一个独立的应用，与本地应用隔离，多个应用可直接的共享缓存，像memcached、redis、tair都是分布式缓存。</p>
<p>缓存使用实践<br />
缓存的使用也是讲究一定技巧性，如果使用不当会导致数据一致性问题、缓存被穿透导致应用雪崩等。<br />
上面讲到局部性原理，简单介绍下与缓存相关的局部性原理：</p>
<p>时间局部性（temporal locality）：数据将被多次访问<br />
空间局部性（spatial locality）：邻近数据将被访问<br />
基于局部性原理，缓存在设计上需要考虑许多的因素：</p>
<p>缓存关联性（cache associativity）<br />
写策略（writing policy）<br />
替换策略（cache replacement）<br />
缓存一致性（cache coherency）<br />
cache失效可能引发的dog-piling效应（cache stampede）<br />
.....<br />
接下来将会根据以上几点介绍缓存使用的一些实践。</p>
<p>缓存与DB数据一致性<br />
数据的更新与缓存同步，没有高科技含量，但要做好并不容易，有些场景需要做到实时一致性，有些场景需要做到最终一致性。<br /><a href="http://static.roncoo.com/face/fFjX5GhxptZKnTsycHbe4BpdCa8Shs65.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLnJvbmNvby5jb20vZmFjZS9mRmpYNUdoeHB0WktuVHN5Y0hiZTRCcGRDYThTaHM2NS5qcGc=.jpg"></a></p>
<p>如果要做到强一致性，可以采取以下方案：</p>
<p>数据库更新后，删除缓存。<br />
这种方式的优点是实现简单，缺点是删除缓存后，如果有多个查询请求并发过来，都发现缓存中没数据，都会将请求落到数据库上，导致数据库压力瞬间增加。</p>
<p>数据库更新后，更新缓存。<br />
这是对删除方式的改进，但也有缺点，写入前要多一次查询，在部分场景下是没法使用的，比如分页查询场景，各种请求参数组合很多，应用无法知道有多少种key，自然无法主动写入，只能等缓存失效。</p>
<p>以上两种实时同步缓存机制，先操作数据库然后操作缓存，因异构数据存储无法通过事务保证一致。当然缓存涉及到网络IO开销，如果连接分布式缓存超时也需要考虑，否则会出现事务超时，导致应用线程挂起。</p>
<p>如果要做到最终一致性，可以采取以下方案：</p>
<p>MQ异步刷新、定时刷新 采用MQ异步消息机制刷新，如果更新失败要有适当的补偿机制。所有需要更新的对象存储到一张定时任务表，定时任务扫描任务表异步更新。这两种更新机制不能保证查询缓存同DB的一致性，但是能够保证最终一致性。</p>
<p>自动失效 合理设置缓存失效时间，需根据业务场景设置每个缓存的失效时间，一致性要求越高，自然失效时间也要越短。</p>
<p>缓存并发<br />
缓存过期后将尝试从后端数据库获取数据，这是一个看似合理的流程。但是，在高并发场景下，有可能多个请求并发的去从数据库获取数据，对后端数据库造成极大的冲击，甚至导致 “雪崩”现象。此外，当某个缓存key在被更新时，同时也可能被大量请求在获取，这也会导致一致性的问题。那如何避免类似问题呢？我们会想到类似"锁"的机制(可重入锁)，在缓存更新或者过期的情况下，先尝试获取到锁，当更新或者从数据库获取完成后再释放锁，其他的请求只需要牺牲一定的等待时间，即可直接从缓存中继续获取数据。<br /><a href="http://static.roncoo.com/face/dFWXybKkBFkaEyxJ8xMydFrMmNa7Raks.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLnJvbmNvby5jb20vZmFjZS9kRldYeWJLa0JGa2FFeXhKOHhNeWRGck1tTmE3UmFrcy5qcGc=.jpg"></a><br />
缓存被穿透<br />
在高并发场景下，如果某一个key被高并发访问，没有被命中，出于对容错性考虑，会尝试去从后端数据库中获取，从而导致了大量请求达到数据库，而当该key对应的数据本身就是空的情况下，这就导致数据库中并发的去执行了很多不必要的查询操作，从而导致巨大冲击和压力。</p>
<p>我们在应用中使用缓存的时候，很可能就是使用的如下代码所表示的逻辑的方式。　先获取缓存中的数据，如果为空则查询数据库或者其他方式获取数据，然后再存入缓存，返回数据，如下伪代码。</p>
<pre><code>data=cache.get(key);
if(data=null || !isValid(data)){
　　　sql="SELECT ......";
     data=db.query(sql);
　　　//data可能为null
     if(data ！= null){
        cache.set(key,data,expire);
      }
 }
return data;
</code></pre>
<p>相信大多数人会认为这段代码没有问题，很多人也是这么去写的。</p>
<p>问题：<br />
当key的内容在数据库也不存在时，那么上面代码中的data始终为null，缓存中也始终没有数据，如果这个key的请求突然变得很大（很多情况下都会发生，比如查询请求不存在的数据），那么将会有大量的请求绕过缓存，直接到了后端数据库，对数据库的IOQPS造成过大的冲击，最后很可能导致系统崩溃。</p>
<p>解决方案：<br />
1. 缓存空对象<br />
解决这个问题的办法就是当数据库查询到null时，我们也应该把null进行相应的缓存。<br />
比如数据库返回的是一个list，那么我们可以存入一个空的list来处理cache.set(key,new List(),expire)。<br />
同时，也需要保证缓存数据的时效性。这种方式实现起来成本较低，比较适合命中不高，但可能被频繁更新的数据。<br />
2. 单独做过滤处理<br />
对所有可能对应数据为空的key进行统一的存放，并在请求前做拦截，这样避免请求穿透到后端数据库。这种方式实现起来相对复杂，比较适合命中不高，但是更新不频繁的数据。</p>
<p>比较常用的方案是通过Bloom Filter提前拦截，Bloom Filter是一个空间效率很高的随机数据结构，它由一个位数组和一组hash映射函数组成。Bloom Filter可以用于检索一个元素是否在一个集合中，它的优点是空间效率和查询时间都远远超过一般的算法，缺点是有一定的误识别率。因此Bloom Filter不适合那些“零错误”的应用场合。而在能容忍低错误率的应用场合下,Bloom Filter通过极少的错误换取了存储空间的极大节省。</p>
<p>像Guava Cache、Google的bigtable都有类似bloomfilter实现，关于bloomfilter具体可以参考：<a href="https://www.javacodegeeks.com/2012/11/bloom-filter-implementation-in-java-on-github.html" rel="external nofollow noreferrer">https://www.javacodegeeks.com/2012/11/bloom-filter-implementation-in-java-on-github.html</a><br /><a href="http://static.roncoo.com/face/HeZzMc4T838KD5YJnAiPxFTEzQ6MZ5ZC.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhdGljLnJvbmNvby5jb20vZmFjZS9IZVp6TWM0VDgzOEtENVlKbkFpUHhGVEV6UTZNWjVaQy5qcGc=.jpg"></a></p>
<p>以上两种方案均可以保障的缓存被穿透问题，第一种方案更简单，但需要额外占一些缓存空间。第二种方案复杂一些，但是占用缓存空间少。</p>
<p>热点缓存</p>
<p>比如key XXX对应的数据访问量特别大，但是XXX在缓存中是有失效时间的。一旦缓存失效，会有N多线程并发的去请求数据库，然后更新缓存，这个时候会导致系统压力过大。通常有这么几种解决方法：<br />
1. 加锁，同时只允许一个线程去查询数据库并更新缓存<br />
2. 缓存不加失效时间，但后台有个异步线程定期的去更新它<br />
3. 引入类似于Hystrix的熔断机制，只允许一定量的请求去请求数据库并更新缓存</p>
<p>比如缓存使用memcached、redis，可以考虑如上方案针对热点数据。如果使用tair缓存的话，tair提供了hotkey的解决方案，主要原理开启本地LocalCache功能，每次写操作会自动强制删除 Localcache 里存在的 key，读操作后会自动从 Localcache 里读取， Localcache 中不存在则从服务端获取，成功后存储到 Localcache 里。在 Hotkey 防御系统中，客户端要开启 hot-running 模式，该模式下只能缓存带热点标记的 key，Localcache 中非热点的 key 将逐步被淘汰。即一旦开启客户端的该模式，会强制改变 Localcache 的工作模式。</p>
<p>数据缓存模式通常有懒加载和预加载两种模式，但是对于热点缓存最好采取预加载模式，笔者曾经遇到应用系统刚发布完就直接挂掉的案例，一些热点数据查询在高并发场景下还没有加载进来，请求流量就涌入进来。</p>
<p>缓存大对象</p>
<p>某些场景下我们想要把一些大对象缓存起来，因为产生一次大对象的代价很大，我们需要产生一次，尽可能的多次使用，从而提升QPS。</p>
<p>通常的解决方案是对数据进行压缩，压缩可以在客户端进行压缩，缓存服务端也可以压缩，像memcached的话需要在客户端进行压缩，可以采用gzip压缩算法进行压缩，像tair的话如果value超过一定的阈值服务端会自动对value进行压缩。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:21:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/%e4%ba%92%e8%81%94%e7%bd%91/" title="互联网">互联网</a>, <a href="https://www.iamivan.net/tag/%e7%bc%93%e5%ad%98/" title="缓存">缓存</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/cache/" title="Cache">Cache</a>, <a href="https://www.iamivan.net/tag/%e9%ab%98%e5%b9%b6%e5%8f%91/" title="高并发">高并发</a>, <a href="https://www.iamivan.net/tag/%e7%bc%93%e5%ad%98%e6%9e%b6%e6%9e%84/" title="缓存架构">缓存架构</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>互联网应用的缓存实践分享的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGqQ5p.html" rel="bookmark">微信小程序第一手实践分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是微信小程序第一手实践分享,今天是微信小程序正式上线的第一天,从小程序公布.内测到今天,市面上对于小程序众说纷纭,小程序的到来给我们(微信开发)带来了什么,仅仅是又多了一种推广渠道吗?又或者是真的像外界说的那样它将取代APP?今天就和大家分享我个人对小程序的理解以及开发过程中的一些体会. 一.如何理解小程序 张小龙是基于他对未来服务场景--所见即所得的信息交互过程提出的小程序,他认为微信新形式的服务不应当只是停留在原有公众号订阅.推送的基础上:而应当更类似于APP支持一些扩展开发的能力但			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgR958b.html" rel="bookmark">DockOne微信分享（七十八）：中英人寿保险有限公司基于容器技术的实践分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是DockOne微信分享(七十八):中英人寿保险有限公司基于容器技术的实践分享[编者的话] 中英人寿在移动应用开发与运维上引入DevOps,极大的提升了开发效率,进而实现持续交付能力.持续交付让移动应用上线的速度从以月为单位提升到周甚至到天. 通过在企业云上使用(Docker.Git.Jenkins etc)搭建自动化部署流水线, 使软件的构建.测试.部署的过程自动化实现.随着IT架构向云架构的转型,在架构级管理工具上采用虚拟化容器管理,实现从IaaS到PaaS的转变.对移动应用系统进行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlKKENb.html" rel="bookmark">如何快速复制阿里&rdquo;企业级互联网架构&OpenCurlyDoubleQuote;的最佳实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本期采访嘉宾--赵林 (丹臣),&lt;企业级互联网架构专场&gt;出品人. 2016云栖大会深圳峰会,点击报名! 企业级互联网架构解决方案,点击查看! 赵林:这次之所以策划这个主题,主要是想帮助那些由传统IT架构到企业级互联网架构跨越式升级的企业,实现互联网转型,共同应对互联网+浪潮的挑战. 以前,阿里中间件事业部其实是一个为内部各BU提供企业级高可用互联网应用架构支撑的平台型支撑部门.近两年,我们尝试着将我们已经比较稳定和可靠的分布式系统架构以服务的形式对外提供实践,帮助了很多传统的IT企业在软件研发			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgR5BBb.html" rel="bookmark">【CSDN在线培训Q&sol;A】Amazon Kinesis实时数据分析最佳实践分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 1月8日,亚马逊AWS的产品拓展经理庄富任在主题为&quot;AmazonKinesis实时数据分析最佳实践分享&quot;的在线培训中,为我们讲述了如何利用Kinesis架构实时数据流处理和分析的能力,并透过目前最热门的手游开发商Supercell客户案例,来体现Kinesis如何处理和分析海量数据流(例如用户的点击,消费,上线等动作).为了帮助大家更好的复习本次培训的相关内容,了解如何在AWS这样的云平台进行数据分析.CSDN整理了本次培训最后的QA,如下:Q1.目前Strom的社区进展缓慢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlAPlOp.html" rel="bookmark">首期京东技术沙龙聚焦《互联网测试技术与实践》</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				8月8日,在京东技术分享日之外,秉着信任.分享.学习.成长的态度,首期&lt;互联网测试技术与实践&gt;京东技术沙龙也正式启动.除了京东的技术专家外,还有百度.阿里的技术大拿参与分享,大家针对不同的测试项目进行解说. 阿里巴巴测试专家闺蜜在几家互联网巨头公司中都有任职经历,本次他分享的是和浏览器相关的测试.了解浏览器测试首先需要了解浏览器的组成结构,同时分别对比了IE.Chrome.Firefox.Safari等不同浏览器之间的区别,而根据不同浏览器在渲染引擎和线程上的差别,在测试上也有不同的方法. 阿			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrDEJjz.html" rel="bookmark">OceanBase 互联网时代的关系数据库实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				​ 12 月 7 - 9 日,一年一度的中国大数据技术大会(BDTC 2017)在北京召开,作为国内最具影响力的大数据领域技术盛会之一,今年大会围绕&quot;大数据与智能&quot;的主题,对大数据时代社会各行业的智能化进程和行业实践展开深度分享与讨论. 在本次大会上,蚂蚁金服高级研究员.OceanBase分布式关系数据库负责人阳振坤发表了主题为&lt;OceanBase-互联网时代的关系数据库实践&gt;的演讲.本文是此次演讲的精华内容集合. 阳振坤:有这么多人在周末还来听数据库的讲座确实令人很高兴,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3eVPz.html" rel="bookmark">打造云上代码交付链，CodePipeline实践分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在2017在线技术峰会--首届阿里巴巴研发效能嘉年华上,来自阿里云飞天研发部的工程师莫源分享了&lt;打造云上代码交付链,CodePipeline实践分享&gt;.他在云计算和云平台.持续集成流程.DevOps的基础上,详细分享了Alibaba Cloud CodePipeline优于Jenkins的性能和实践. 以下内容根据直播视频整理而成. 直播视频:https://yq.aliyun.com/edu/lesson/549 PDF下载:https://yq.aliyun.com/attachment/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdyZn6z.html" rel="bookmark">基于MaxCompute的图计算实践分享-常见问题解决及优化指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				免费开通大数据服务:https://www.aliyun.com/product/odps 常见问题FAQ Q:Graph 能支持多少节点的进行计算? A:默认最多1000个节点,通过配置odps.graph.worker.num,可以使用多达3000个节点   Q:Graph 单个节点支持多少内存? A:默认内存范围为[2048, 32768] 单位为M,通过配置odps.graph.worker.memory 设置所需内存,如果单个节点需要设置超过32768M的内存,请找ODPS 管理员修改			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOJvmqp.html" rel="bookmark">蒋帆：区块链落地实践分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是蒋帆:区块链落地实践分享 分享主题:区块链落地时的问题域和主要实践方法,如&quot;区块风暴工作坊&quot;.&quot;区块链的敏捷开发与Devops实践&quot;.&quot;内建安全的区块链应用&quot;等关键活动. 讲师介绍:蒋帆,Fabulous J,ThoughtWorks高级咨询师,在北京与厄瓜多尔,从事信息安全与隐私加密协议研发,熟悉密码学.数字货币与网络通讯协议等领域. 分享内容如下:1.ThoughtWorks 在中国区为客户提供的区块链服务 2.Blockchain			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5VOBz.html" rel="bookmark" class="title">Live Write 的代码高亮插件 Paste Code</a>
					<div>
						然后用了一下VSPaste(原作者网站已经找不到了),感觉代码显示不爽.也用了CodePoste(呵呵,也是看网上找到的),这个感觉还不错的说,不过行数的显示让我觉得有些不爽.本来还想参考一下他的代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4RJ8M.html" rel="bookmark" class="title">php&amp;amp&semi;amp&semi;java（三）</a>
					<div>
						例子二:通过Xalan 1.2,使用XSLT转换XML 做为第二个例子,我们使用了Xalan-java的XSLT引擎,这个引擎来自于APACHE的XML项目,使用这个程序,我们能够使用XSL转换XML ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpngGoz.html" rel="bookmark" class="title">利用权重较高的网站增加新站收录</a>
					<div>
						  新站内容页的收录问题,一直都是很多站长头疼的问题,新站收录不佳,导致友链不好找,更别说希望通过内容页面的长尾词带来流量了.那么该如何避免这个问题,适当增加内容页的收录呢?首先我们要弄明白的就是为什 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M05WDp.html" rel="bookmark" class="title">SEO人员如何快速获取准确的关键字</a>
					<div>
						关键字是SEO人员最重要的一份资料,凡是做SEO的人员,都会对关键字这块备受推崇,可以说关键字的好坏决定了网站的流量和排名.获取关键字的方法也有很多种,我们一起来聊聊,关于如何快速获取准确的关键字.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1yodM.html" rel="bookmark" class="title">蜜罐技术原理</a>
					<div>
						1.引言 随着人类社会生活对Internet需求的日益增长,网络安全逐渐成为Internet及各项网络服务和应用进一步发展的关键问题,特别是1993年以后Internet开始商用化,通过Interne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE9KWb.html" rel="bookmark" class="title">css-sprite使用详解</a>
					<div>
						  可能是最好用的雪碧图工具了,好吧,至少是我用过最好用的. 首先安装css-sprite,安装这里很坑,等我最后再说. 代码如下: npm install css-sprite 我是使用gulp来构 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kKwKz.html" rel="bookmark" class="title">如何防止自己的IP泄漏</a>
					<div>
						  黑客会采取各种手段,探测对方的主机信息,以便决定使用何种最有效的方法达到自己的目的.来看看黑客是如何获知最基本的网络信息--对方的IP地址,以便用户如何防范自己的IP泄漏. &quot;IP&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZvANb.html" rel="bookmark" class="title">删除Windows7通知区域的无效旧图标的方法</a>
					<div>
						Windows7操作系统经过一段时间的使用之后,在任务栏的通知区域会遗留下大量无效的旧程序图标,这些程序甚至可能已经被卸载掉了.那么,要如何操作才能删除这些无效的旧图标呢?请跟着墨染暖心的操作,一步步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwYgmb.html" rel="bookmark" class="title">Mac OS X如何重装</a>
					<div>
						  1.首先在 MacBook Air 关上的情况下,按着 Command 及 R 两个按键不放手,然后同时按下最右上角的开关键一下(记着此时仍然继续按着 Command + R 键). 2.当进入至 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oPBAb.html" rel="bookmark" class="title">关于atmga8a的问题～这里有一个RHF格式的固件但是不知道怎么将它烧到单片机中去</a>
					<div>
						问题描述 关于atmga8a的问题-这里有一个RHF格式的固件但是不知道怎么将它烧到单片机中去 文件的开头部分,接下来就是一段代码[Header]Product Name = School Kits  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEPl1z.html" rel="bookmark" class="title">Oracle insert 加速方法总结</a>
					<div>
						给表提前预分配空间 先删除索引,然后统一建索引 禁用相关约束,最后再启动约束 /*+append*/提示 bulk insert 开启并行,并行与/*+append*/提示不要同时用 不归档 COMM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZl1Ab.html" rel="bookmark" class="title">程序-重新制作java编译工具</a>
					<div>
						问题描述 重新制作java编译工具 如题,请问该如何制作呢? 还有我很想知道,使用eclipse编译java的时候,为什么按&quot;.&quot;号之后会出现一个提示方框,我想知道eclipse实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lK13b.html" rel="bookmark" class="title">云计算如何改变数据中心的设计运维成本</a>
					<div>
						文章讲的是云计算如何改变数据中心的设计运维成本,随着数据中心向云技术的靠拢,低成本.大规模的运行环境已经成为不可阻挡的历史走向.而那些陈旧的设计与经济模式则逐渐淡出了人们的视野. 虽然许多人认为比起云 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAaKkM.html" rel="bookmark" class="title">android asynctask-AsyncTask 不能在 4&period;0&period;4 上运行</a>
					<div>
						问题描述 AsyncTask 不能在 4.0.4 上运行 我创建了一个类,这个类连接互联网,然后发送一个请求到php script.我创建的就像 AsyncTask一样,不在主线程中,为了能在4.0. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkegdwb.html" rel="bookmark" class="title">DDoS攻击不算事 Bondnet僵尸网络可挖矿</a>
					<div>
						利用僵尸网络发动DDoS攻击在安全界来说已经不算事了,但现在有安全公司发现,名为&quot;Bondnet&quot;的僵尸网络通过控制超过15000台的服务器,不仅能够发动DDoS攻击.窃取企业的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAxPvp.html" rel="bookmark" class="title">如何判断用户是否绕开登录直接访问系统内页面</a>
					<div>
						问题描述 描述:系统的用户是政府的工地巡查人员,用的是平板插手机卡上网的方式登录系统.因为信号不稳定,原来的Session保存登录身份信息的方式不行,Session经常会断开,会让用户重新登录.所以把 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boK4KXb.html" rel="bookmark" class="title">java-2014-01-04 20&colon;37 csdn&period;net服务器遭到攻击了么？</a>
					<div>
						问题描述 2014-01-04 20:37 csdn.net服务器遭到攻击了么? csdn.net 论坛进不了,转跳到Csdn.net这个页面,页面内首字母C是大写的,后面是小写,显示 &quot;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoKv0M.html" rel="bookmark" class="title">破解加密系统 如何人不知鬼不觉地设置后门</a>
					<div>
						本文讲的是 破解加密系统 如何人不知鬼不觉地设置后门,在密码学领域,秘密植入可窃听通信数据的&quot;后门&quot;是长期以来困扰众学者的噩梦,但这并不意味着密码学家们就不能欣赏破密者的解密艺术. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60dJLz.html" rel="bookmark" class="title">JSP页面无法显示数据库信息？？？求助啊！有图有代码，求大神雪中送炭</a>
					<div>
						问题描述 JSP页面无法显示数据库信息???求助啊!有图有代码,求大神雪中送炭 JSP页面显示这样:JSP代码: &lt;%@ page language=&quot;&quot;java&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW4nEz.html" rel="bookmark" class="title">杨千嬅倡导非暴力生活夫妻相处靠包容沟通&lpar;图&rpar;</a>
					<div>
						杨千嬅帅气亮相 杨千嬅街头宣讲 杨千嬅笑容灿烂 港姐陈庭欣到场 新浪娱乐讯 11月24日,香港举办国际消除对妇女暴力日宣讲活动,杨千嬅.港姐陈庭欣.张秀文.范徐丽泰博士.何超琼等出席. 谈到妇女惨遭暴 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVEyBz.html" rel="bookmark" class="title">Android应用退出功能实现方法</a>
					<div>
						虽然文档里没有明确说明,但假如这是常用功能,应该有简便的方法实现,而实际上要靠代码&quot;退出&quot;一个应用并非易事.以下总结了能够模拟退出效果的两个方案: 方案1:打开系统主屏来模拟应用退 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ2v3Yz.html" rel="bookmark" class="title">PHP提取字符串中的图片地址&lbrack;正则表达式&rsqb;&lowbar;php技巧</a>
					<div>
						复制代码 代码如下: &lt;?php $str='&lt;p&gt;&lt;img border=&quot;0&quot; src=&quot;upfiles/2009/07/1246430143 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYaoab.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;&period;中国&rdquo;域名8月全球启用  注册潮打响品牌保卫战</a>
					<div>
						&quot;.中国&quot;域名8月全球启用  注册潮打响品牌保卫战 8月起,网民只要在浏览器地址栏中直接输入繁简&quot;中文.中国&quot;域名即可访问相关网站.全球数十亿使用中文的网民,在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5eg5z.html" rel="bookmark" class="title">listview 中数据库数据如何实时跟新</a>
					<div>
						问题描述 listview 中数据库数据如何实时跟新 listview 中button,当点击button时跟新数据库数据, 是在自定义的sampleadapter中实现button的点击事件, 如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWWO9p.html" rel="bookmark" class="title">几款提高效率的链接测试软件</a>
					<div>
						摘要: 网站上的网页是互相链接的,单击被称为超链接的文本或图形就可以链接到其他页面.整个网站的链接犹如一张庞大的蜘蛛网,稍不留神就会有所遗漏.尽管网站的链接测试看起来似乎 网站上的网页是互相链接的,单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByGaAz.html" rel="bookmark" class="title">视网膜屏iPad mini今日上市 中国区同步首发</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 [21136.html&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyQZWM.html" rel="bookmark" class="title">紫光股份IPv6底牌曝光游资主力筹码松动</a>
					<div>
						晓晴 紫光股份(000938.SZ)无疑是沪深两市节后开市以来炙手可热的明星股之一.开市两个交易日连续以 涨停板报收,为此,公司不得不停牌一日进行自查.此前,紫光股份股票交易价格于2011年2月1日. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9vqx3p.html" rel="bookmark" class="title">中兴通讯南京将建成全球云计算中心</a>
					<div>
						(通讯员 谢群 记者 倪敏)记者昨日从雨花台区获悉,随着中兴通讯二区新址投入使用,中兴通讯南京将建成全球云计算中心,实现&quot;万人共享一片云&quot;. 据介绍,该中心将首先用于中兴南京的上万 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZRD5Oz.html" rel="bookmark" class="title">OCZ Vertex固态硬盘将采用Indilinx芯片</a>
					<div>
						       众所周知,控制芯片对于固态硬盘的性能发挥有着极其重要的作用.OCZ的固态硬盘产品以往一直采用JMicron公司的控制芯片,包括今年年初刚刚推出的新中端Apex系列.但据报道,OCZ将在即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqOm9ez.html" rel="bookmark" class="title">智能合约不够安全？微软建专项小组从编程语言入手根治</a>
					<div>
						据外媒报道,微软对外公开其已经成立了一个专门负责提高智能合约安全性的工作小组&quot;Kinakuta&quot;,旨在让行业内共享智能合约信息和协议更加简单. 所谓智能合约,是指基于区块链自动执行 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
